#!/usr/bin/python2

import sys

def load_pc_profile_map(file_):
    trace = open(file_, 'r')
    mapa = {}
    while True:
        line = trace.readline()
        if line == '' : break
        line = line[:-1] # remove the \n char
        line = line.split(',')
        for i in range(2,2 + int(line[1]), 3) :
            key = line[i][1:]
            if not mapa.has_key(key) :
                mapa[key] = [0, 0]
            mapa[key][0] += int(line[i+1])
            if int(line[i+2]) == 0 : mapa[key][1] += 1
            else : mapa[key][1] += int(line[i+2])
    return mapa

def filter_pc_frequency(mapa, limit) :
    list = []
    for value in mapa.keys() :
        if (mapa[value][0] / mapa[value][1])  >= limit : list.append(value)
    return list

def load_profile_map(file_) :
    trace = open(file_, 'r')
    mapa = {}
    while True:
        line = trace.readline()
        if line == '' : break
        line = line[:-1] # remove the \n char
        line = line.split(',')
        key = line[0]
        accesses = 0
        for i in range(2,2 + int(line[1]), 3) :
            accesses += int(line[i+1]) + int(line[i+2])
        mapa[key] = accesses
    return mapa
    
def repetition_frequency(mapa) :
    freq = {}
    for value in mapa.values() :
        freq[value] = freq.get(value, 0) + 1
    return freq
    
def filter_frequency(mapa, limit) :
    list = []
    for value in mapa.keys() :
        if mapa[value] >= limit : list.append(value)
    return list
    
file = "/home/martit/projects/simulations/logs/reusability_stats.csv"

if len(sys.argv) == 3 and sys.argv[1] == "addr" :
    mapa = load_profile_map(sys.argv[2])
    freq = repetition_frequency(mapa)
    for elem in freq.keys() : print str(elem) + ", " + str(freq[elem])
elif len(sys.argv) == 3 and sys.argv[1] == "pc" :
    mapa = load_pc_profile_map(sys.argv[2])
    for elem in mapa.keys() : 
        print str(elem) + ": " \
        + str(mapa[elem][0]) +  ", " \
        + str(mapa[elem][1]) + ", " \
        + str(mapa[elem][0] / mapa[elem][1])
elif  len(sys.argv) == 4 and sys.argv[1] == "addr" :
    mapa = load_profile_map(sys.argv[2])
    list = filter_frequency (mapa, int(sys.argv[3]))
    for elem in list : print elem
elif  len(sys.argv) == 4 and sys.argv[1] == "pc" :
    mapa = load_pc_profile_map(sys.argv[2])
    list = filter_pc_frequency (mapa, int(sys.argv[3]))
    for elem in list : print elem
else :
    print "Usage: " + sys.argv[0] + " pc/addr reusability_stats.csv [ filter_value ] "
    print "Example: " + sys.argv[0] + " pc/addr " + file + " [ 3 ]"
